"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var Tag_1 = require("../Tag");
var parseFilter = function (filter) {
    if (!filter) {
        return {};
    }
    try {
        return JSON.parse(filter.description);
    }
    catch (err) {
        return { value: filter.description };
    }
};
var FilterDescription = function (_a) {
    var filter = _a.filter, props = __rest(_a, ["filter"]);
    var tagProps = filter.anyOf
        ? filter.anyOf.map(function (filterFragment, i) {
            var parsedFilter = parseFilter(filterFragment);
            if (i > 0) {
                parsedFilter.prefix = 'or';
            }
            return parsedFilter;
        })
        : [parseFilter(filter)];
    return React.createElement(Tag_1.Tag, __assign({ mt: 2, multiple: tagProps }, props));
};
exports.default = FilterDescription;
