import { SelectProps as GrommetSelectProps } from 'grommet';
import * as React from 'react';
import { DefaultProps, Omit, RenditionSystemProps } from '../../common-types';
declare type AdjustedGrommetSelectProps = Omit<GrommetSelectProps, 'onChange' | 'children'>;
interface InternalSelectProps<T> extends AdjustedGrommetSelectProps, Omit<DefaultProps, 'onChange'> {
    emphasized?: boolean;
    onChange: (data: {
        option: T;
        selected: number;
        target: React.ChangeEvent<HTMLElement>;
        value: T;
    }) => void;
    children?: (option: T, index: number, options: T[], state: {
        active: boolean;
        disabled: boolean;
        selected: boolean;
    }) => void;
}
export interface SelectProps<T> extends Omit<InternalSelectProps<T>, 'size' | 'selected' | 'focusIndicator' | 'margin'>, RenditionSystemProps {
}
declare const _default: <T extends {}>(props: SelectProps<T>) => JSX.Element;
export default _default;
