import { __assign, __rest } from "tslib";
import * as React from 'react';
import { Tag } from '../Tag';
var parseFilter = function (filter) {
    if (!filter) {
        return {};
    }
    try {
        return JSON.parse(filter.description);
    }
    catch (err) {
        return { value: filter.description };
    }
};
var FilterDescription = function (_a) {
    var filter = _a.filter, props = __rest(_a, ["filter"]);
    var tagProps = filter.anyOf
        ? filter.anyOf.map(function (filterFragment, i) {
            var parsedFilter = parseFilter(filterFragment);
            if (i > 0) {
                parsedFilter.prefix = 'or';
            }
            return parsedFilter;
        })
        : [parseFilter(filter)];
    return React.createElement(Tag, __assign({ mt: 2, multiple: tagProps }, props));
};
export default FilterDescription;
